﻿#include <amxmodx>
#include <amxmisc>
#include <nvault>
#include <fakemeta>
#include <ColorChat>

new name[33][32];
new ip[33][24];

new plik_vault;
new Trie:MuteNaMape;

public plugin_init(){
	register_plugin("Perm Mute/Mute", "2.0c", "HubertTM");
	plik_vault = nvault_open("PermMute");
	MuteNaMape = TrieCreate();
	
	register_clcmd("amx_permmute", "DajMute", 0, "<name>");
	register_clcmd("amx_permmute_menu", "DajMuteMenu");
	register_clcmd("amx_permmutemenu", "DajMuteMenu");
	
	register_clcmd("amx_unmutemenu", "DajUnmuteMenu");
	register_clcmd("amx_unmute_menu", "DajUnmuteMenu");
	register_clcmd("amx_unpermmute_menu", "DajUnmuteMenu");
	register_clcmd("amx_unpermmutemenu", "DajUnmuteMenu");
	
	register_clcmd("amx_mute2", "DajMute2", 0, "<name>");
	register_clcmd("amx_mute2menu", "DajMuteMenu2", 0, "<name>");
	register_clcmd("amx_mute2_menu", "DajMuteMenu2", 0, "<name>");
	
	register_forward(FM_Voice_SetClientListening, "Voice_SetClientListening");
}


public client_putinserver(id){
	name[id] = "";
	ip[id] = "";

	if(task_exists(id+5802))
	remove_task(id+5802);
	
	set_task(1.0, "Wczytaj", id+5802);
}

public client_disconnect(id){
	if(task_exists(id+5802)){
		remove_task(id+5802);
		return;
	}

	name[id] = "";
	ip[id] = "";
}


public Wczytaj(id){
	id-=5802;
	
	if(is_user_connected(id)){
		get_user_name(id, name[id], 31);
		get_user_ip(id, ip[id], 23);
		
		
		if(!TrieKeyExists(MuteNaMape, name[id]) && !TrieKeyExists(MuteNaMape, ip[id]))
		wczytaj_mute(id);
	}
}

public DajMuteMenu(id){
	if(!(get_user_flags(id) & read_flags("c")) && id != 0)
	return PLUGIN_HANDLED;
	
	new menu = menu_create("Кого заткнуть \r[На всегда]?", "DajMuteMenuH");
	for(new i=1; i<33; i++){
		if(is_user_connected(i) && !TrieKeyExists(MuteNaMape, name[i]) && !TrieKeyExists(MuteNaMape, ip[i]) && !(get_user_flags(i) & read_flags("a")))	
		menu_additem(menu, name[i]);
	}
	menu_display(id, menu);
	
	
	return PLUGIN_HANDLED
}

public DajMuteMenuH(id, menu, item){
	if(item == MENU_EXIT)
	return PLUGIN_HANDLED;
	
	if(!is_user_connected(id))
	return PLUGIN_HANDLED;
	
	new acces, info[6], name2[32], callback;
	
	menu_item_getinfo(menu, item, acces, info, 5, name2, 31, callback);
	
	new player = cmd_target(id, name2, CMDTARGET_ALLOW_SELF)
	
	new namea[32];
	get_user_name(id, namea, 31);
	
	if (!player || !is_user_connected(player))
	{
		console_print(id, "Игрок ^"%s^" не найден.",name2);
		return PLUGIN_HANDLED;
	}
	else
	{
		client_print(id, print_console,"Вы замутили игрока: %s!", name2);
		TrieSetCell(MuteNaMape, name[player], 1); 
		TrieSetCell(MuteNaMape, ip[player], 1);
		zapisz_mute(player);
		client_cmd(player, "-voicerecord");
		ColorChat(0, GREEN, "[Cs-Serva.Net] Игрок %s был заткнут админом: %s", name2, namea);
	}
	return PLUGIN_HANDLED;
}


public DajMuteMenu2(id){
	if(!(get_user_flags(id) & read_flags("c")) && id != 0)
	return PLUGIN_HANDLED;
	
	
	new menu = menu_create("Кого заткнуть \r[на карту] ?", "DajMuteMenuH2");
	for(new i=1; i<33; i++){
		if(is_user_connected(i) && !TrieKeyExists(MuteNaMape, name[i]) && !TrieKeyExists(MuteNaMape, ip[i]) && !(get_user_flags(i) & read_flags("a")))	
		menu_additem(menu, name[i]);
	}
	menu_display(id, menu);
	
	
	return PLUGIN_HANDLED
}

public DajMuteMenuH2(id, menu, item){
	if(item == MENU_EXIT)
	return PLUGIN_HANDLED;
	
	if(!is_user_connected(id))
	return PLUGIN_HANDLED;
	
	new acces, info[6], name2[32], callback;
	
	menu_item_getinfo(menu, item, acces, info, 5, name2, 31, callback);
	
	new player = cmd_target(id, name2, CMDTARGET_ALLOW_SELF)

	new namea[32];
	get_user_name(id, namea, 31);
	
	if (!player || !is_user_connected(player))
	{
		console_print(id, "Игрок ^"%s^" не найден.",name2);
		return PLUGIN_HANDLED;
	}
	else
	{
		client_print(id, print_console,"Вы замутили игрока: %s!", name2);
		
		TrieSetCell(MuteNaMape, name[player], 1); 
		TrieSetCell(MuteNaMape, ip[player], 1);
		
		client_cmd(player, "-voicerecord");
		ColorChat(0, GREEN, "[Cs-Serva.Net] Игрок %s был заткнут админом: %s", name2, namea);
	}
	return PLUGIN_HANDLED;
}


public DajUnmuteMenu(id){
	if(!(get_user_flags(id) & read_flags("c")) && id != 0)
	return PLUGIN_HANDLED;
	
	
	new menu = menu_create("Кого размутить?", "DajUnmuteMenuH");
	for(new i=1; i<33; i++){
		if(is_user_connected(i) && (TrieKeyExists(MuteNaMape, name[i]) || TrieKeyExists(MuteNaMape, ip[i])))	
		menu_additem(menu, name[i]);
	}
	menu_display(id, menu);
	
	
	return PLUGIN_HANDLED
}

public DajUnmuteMenuH(id, menu, item){
	if(item == MENU_EXIT)
	return PLUGIN_HANDLED;
	
	if(!is_user_connected(id))
	return PLUGIN_HANDLED;
	
	new acces, info[6], name2[32], callback;
	
	menu_item_getinfo(menu, item, acces, info, 5, name2, 31, callback);
	
	new player = cmd_target(id, name2, CMDTARGET_ALLOW_SELF)
	
	new namea[32];
	get_user_name(id, namea, 31);
	
	if (!player || !is_user_connected(player))
	{
		console_print(id, "Игрок %s не найден.",name2);
		return PLUGIN_HANDLED;
	}
	else
	{
		client_print(id, print_console,"Вы размутили игрока: %s!", name2);
		Odbanuj_Gracza(player);
		
		if(TrieKeyExists(MuteNaMape, name[player]))
		TrieDeleteKey(MuteNaMape, name[player]);
		
		if(TrieKeyExists(MuteNaMape, ip[player]))
		TrieDeleteKey(MuteNaMape, ip[player]);
		
		ColorChat(0, GREEN, "[Cs-Serva.Net] Игрока %s размутил админ: %s", name2, namea);
	}
	return PLUGIN_HANDLED;
}


/* Perm Mute na ZAWSZE przez nick, nawet OFFLINE! */
public DajMute(id){
	if(!(get_user_flags(id) & read_flags("c")) && id != 0)
	return PLUGIN_HANDLED;
	
	new arg1[32];
	read_argv(1, arg1, 31)
	
	if(!arg1[0])
	return PLUGIN_CONTINUE;
	
	new player = cmd_target(id, arg1, CMDTARGET_ALLOW_SELF)
	
	new namea[32];
	get_user_name(id, namea, 31);
	
	if (!player || !is_user_connected(player))
	{
		new cReturn = Z_or_od_banujGracza(arg1, 2, 1)
		if(cReturn){
			ColorChat(0, GREEN, "[Cs-Serva.Net] Игрок %s был заткнут навсегда админом: %s", arg1, namea);
		}
		
		return PLUGIN_HANDLED;
	}
	else
	{
		TrieSetCell(MuteNaMape, name[player], 1); 
		TrieSetCell(MuteNaMape, ip[player], 1);
		zapisz_mute(player);
		client_print(id, print_console,"ZMUTOWANO!");
		ColorChat(0, GREEN, "[Cs-Serva.Net] Игрок %s был заткнут навсегда админом: %s", arg1, namea);
	}
	
	return PLUGIN_HANDLED
}


/* Perm Mute na mape przez nick, bez OFFLINE! */
public DajMute2(id){
	if(!(get_user_flags(id) & read_flags("c")) && id != 0)
	return PLUGIN_HANDLED;
	
	new arg1[32];
	read_argv(1, arg1, 31)
	
	if(!arg1[0])
	return PLUGIN_CONTINUE;
	
	new player=cmd_target(id, arg1, CMDTARGET_ALLOW_SELF)
	
	new namea[32];
	get_user_name(id, namea, 31);
	
	if (!player || !is_user_connected(player))
	{
		console_print(id, "Игрок %s не найден.",arg1);
		return PLUGIN_HANDLED;
	}
	else
	{
		TrieSetCell(MuteNaMape, name[player], 1); 
		TrieSetCell(MuteNaMape, ip[player], 1);
		client_print(id, print_console,"ZMUTOWANO!");
		ColorChat(0, GREEN, "[Cs-Serva.Net] Игрок %s был заткнут на 1 карту админом: %s", arg1, namea);
	}
	
	return PLUGIN_HANDLED
}


public wczytaj_mute(id)
{
	new vaultkey[64], vaultdata[256];
	
	formatex(vaultkey,63,"%s-m-",name[id])
	nvault_get(plik_vault,vaultkey,vaultdata,255) 
	
	new wartosc[6];
	parse(vaultdata, wartosc, 5) 
	
	if(str_to_num(wartosc)){
		TrieSetCell(MuteNaMape, name[id], 1);
	}
	
	formatex(vaultkey,63,"%s-mip-", ip[id]) 
	nvault_get(plik_vault, vaultkey, vaultdata,255) 
	
	new wartosc2[6];
	parse(vaultdata, wartosc2, 5) 
	
	if(str_to_num(wartosc2)){
		TrieSetCell(MuteNaMape, ip[id], 1);
	}
}  


public zapisz_mute(id)
{
	new vaultkey[64], vaultdata[256];
	
	if(TrieKeyExists(MuteNaMape, name[id]))
	{
		formatex(vaultkey, 63, "%s-m-", name[id]);
		formatex(vaultdata, 255, "1");
		nvault_set(plik_vault, vaultkey, vaultdata);
	}
	
	if(TrieKeyExists(MuteNaMape, ip[id]))
	{
		formatex(vaultkey, 63, "%s-mip-", ip[id]) 
		formatex(vaultdata, 255, "1");
		nvault_set(plik_vault, vaultkey, vaultdata);
	}

}

public Odbanuj_Gracza(id){
	new vaultkey[64]; /*, vaultdata[256];*/
	
	formatex(vaultkey, 63, "%s-m-", name[id]) 
	/*formatex(vaultdata, 255, "0") 
	nvault_set(plik_vault, vaultkey, vaultdata)*/
	nvault_remove(plik_vault, vaultkey);
	
	formatex(vaultkey, 63, "%s-mip-", ip[id]) 
	/*formatex(vaultdata, 255, "0") 
	nvault_set(plik_vault, vaultkey, vaultdata)*/
	nvault_remove(plik_vault, vaultkey);
}


public Voice_SetClientListening(odbiorca, nadawca, listen) 
{
	if(odbiorca == nadawca)
	return FMRES_IGNORED;
	
	if(!is_user_connected(nadawca))
	return FMRES_IGNORED;
	
	if(TrieKeyExists(MuteNaMape, name[nadawca]) || TrieKeyExists(MuteNaMape, ip[nadawca]))
	{
		engfunc(EngFunc_SetClientListening, odbiorca, nadawca, false);
		return FMRES_SUPERCEDE;
	}
	
	return FMRES_IGNORED;
}

stock Z_or_od_banujGracza(const text[], bantype=1, wartosc=1){
	new vaultkey[64], vaultdata[256];
	new cReturn = 0;
	
	if(bantype == 1 || bantype == 2){
		formatex(vaultkey, 63, "%s-m-", text);
		formatex(vaultdata, 255, "%d", wartosc);
		nvault_set(plik_vault, vaultkey, vaultdata);	
		cReturn++;
	}
	
	if(bantype == 0 || bantype == 2)
	{
		formatex(vaultkey, 63, "%s-mip-", text);
		formatex(vaultdata, 255, "%d");
		nvault_set(plik_vault, vaultkey, vaultdata);
		cReturn++;
	}
	
	return cReturn;
}